#include "projet.h"

param_hyperb_t hyp_param;
extern GtkWidget *gl_window;

void
hpw_fill_params (GtkWidget * window)
{
  GtkSpinButton *spb;

  spb =
    GTK_SPIN_BUTTON (lookup_widget (GTK_WIDGET (window), "hpw_numitersb"));
  hyp_param.num_iter = gtk_spin_button_get_value_as_int (spb);

  spb = GTK_SPIN_BUTTON (lookup_widget (GTK_WIDGET (window), "hpw_rayminsb"));
  hyp_param.radius_min = gtk_spin_button_get_value_as_int (spb);

  spb = GTK_SPIN_BUTTON (lookup_widget (GTK_WIDGET (window), "hpw_raymaxsb"));
  hyp_param.radius_max = gtk_spin_button_get_value_as_int (spb);

  spb = GTK_SPIN_BUTTON (lookup_widget (GTK_WIDGET (window), "hpw_exposb"));
  hyp_param.power = (double) gtk_spin_button_get_value_as_float (spb);

  spb = GTK_SPIN_BUTTON (lookup_widget (GTK_WIDGET (window), "hpw_factsb"));
  hyp_param.factor = gtk_spin_button_get_value_as_int (spb);

  /*g_print ("parameters: pow=%f, num_iter=%d, radmin=%d, radmax=%d\n",
	   hyp_param.power, hyp_param.num_iter, hyp_param.radius_min,
	   hyp_param.radius_max);*/

}

#if 0
void
on_hpw_numitersb_value_changed (GtkSpinButton * spinbutton,
				gpointer user_data)
{
  int new_value = 50;
  new_value = gtk_spin_button_get_value_as_int (spinbutton);
  /*   g_print("new value: %d\n",new_value);  */
  hyp_param.num_iter = new_value;
}


void
on_hpw_rayminsb_value_changed (GtkSpinButton * spinbutton, gpointer user_data)
{
  int new_value = 10;
  new_value = gtk_spin_button_get_value_as_int (spinbutton);
  /*   g_print("new value: %d\n",new_value);  */
  hyp_param.radius_min = new_value;
}


void
on_hpw_raymaxsb_value_changed (GtkSpinButton * spinbutton, gpointer user_data)
{
  int new_value = 30;
  new_value = gtk_spin_button_get_value_as_int (spinbutton);
  /*   g_print("new value: %d\n",new_value);  */
  hyp_param.radius_max = new_value;

}


void
on_hpw_exposb_value_changed (GtkSpinButton * spinbutton, gpointer user_data)
{
  double new_value = 0.333;
  new_value = (double) gtk_spin_button_get_value_as_float (spinbutton);
  /*   g_print("new value: %f\n",new_value);  */
  hyp_param.power = new_value;
}


void
on_hpw_factsb_value_changed (GtkSpinButton * spinbutton, gpointer user_data)
{
  int new_value = 50;
  new_value = gtk_spin_button_get_value_as_int (spinbutton);
  /*   g_print("new value: %d\n",new_value);  */
  hyp_param.factor = new_value;
}
#endif


void
on_hpw_okb_clicked (GtkButton * button, gpointer user_data)
{
  terrain->size = 129;
  hyp_param.epsilon_type = 0;

  /* recupere les parametres */
  hpw_fill_params (GTK_WIDGET (user_data));
  terrain->spec_param = (void *) &hyp_param;

  gtk_widget_destroy (GTK_WIDGET (user_data));

  gtkglw_activate_buttons();
  
  terrain->algo = TERR_HYPERB;  
  ui_generic_generate_new_terrain (terrain);
}
