#ifndef _COMMON_H_
#define _COMMON_H_

#define randomRange(v) random_float(-v, v)

float get_heightmap_value (terrain_t * terrain, int i, int j);
void set_heightmap_value (terrain_t * terrain, int i, int j, float value);

float random_float (float min, float max);
int random_int (int max);

char create_new_terrain (terrain_t ** terrain);
char init_heightmap (terrain_t * terrain);

void TER_FIL_FIR (terrain_t * terrain, float k);
void TER_FIL_normalize (terrain_t * terrain);
void TER_FIL_denormalize (terrain_t * terrain);
void TER_FIL_power (terrain_t * terrain, float p);
void TER_FIL_multiply (terrain_t * terrain, float m);
void TER_FIL_river (terrain_t * terrain, int L);
void TER_FIL_craters (terrain_t * terrain, float density);
void TER_FIL_allpositive (terrain_t * terrain);
#endif
