#include <stdio.h>
#include <stdlib.h>

#include "terrain.h"

/* on peut trouver sur internet des fichiers .raw qui contiennent les altitudes
 * (en general les donnees sont des unsigned char)
 * ce code est l au cas o mais n'a pas t test 
 */
 
char terr_import_raw(terrain_t *terrain, char * filename)
{
    FILE *pFile = NULL;
    unsigned char *data;
    int result, i=0, j=0;

    pFile = fopen( filename, "rb" );
   
    if ( pFile == NULL ) {
        fprintf(stderr, "Cannot open the file %s", filename);
	return 0;
    }
    
    if (init_heightmap(terrain) == 0) return 0;    

    data = (unsigned char *)calloc((terrain->size)*(terrain->size), sizeof(unsigned char));

    /* Here we load the .raw file into our pHeightMap data array.
      We are only reading in '1', and the size is the (width * height) */
    fread( data , sizeof(unsigned char), terrain->size*terrain->size, pFile );

    /* After we read the data, it's a good idea to check if everything read fine. */
    result = ferror( pFile );
    /* Check if we received an error.*/
    if (result) {
        fprintf(stderr, "Cannot get data from %s", filename);
        return 0;
    }
    
    /* conversion */
    for (i=0; i < terrain->size * terrain->size; i++) {
      terrain->heightmap[i] = (float)data[i];
    }
    free (data);

    /* Close the file. */
    fclose(pFile);
    
    for(j = 0; j < terrain->size; j++) {
      for(i = 0; i < terrain->size; i++) {

      set_heightmap_value(terrain,i,j, get_heightmap_value(terrain,i,j)/8);
      /*printf("h=%f\n",get_heightmap_value(terrain,i,j));*/

      if (get_heightmap_value(terrain,i,j) > terrain->max_height)
        terrain->max_height = get_heightmap_value(terrain,i,j);
    }
  }
  
   printf("maxheight = %f\n", terrain->max_height);
    
    return 1;
}
