#ifndef __PROJET_H__
#define __PROJET_H__

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#ifndef USE_GLUT
 /* includes GTK */
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#endif

#include <glib.h>

#ifndef USE_GLUT
 /* include GtkGLExt et OpenGL */
#include <gtk/gtkgl.h>
#endif

#include <GL/gl.h>
#include <GL/glu.h>
#ifdef USE_GLUT
#include <GL/glut.h>
#endif

/* include de terrain/ */
#include "terrain/terrain.h"

/* includes de l'interface */
#ifndef USE_GLUT
/* includes specifiques  l'interface gtk2 */
#include "gtk2_ui/gtkglw.h"
#include "gtk2_ui/hyp_paraw.h"
#include "gtk2_ui/diamsq_paraw.h"
#include "gtk2_ui/middisp_paraw.h"
#include "gtk2_ui/chxalgow.h"
#include "gtk2_ui/filterw.h"
#include "gtk2_ui/aboutw.h"
#include "gtk2_ui/support.h"
#endif

#include "common_geometry.h"
#include "tessellation.h"
#include "gl_generic.h"
#include "ui_generic.h"
#include "gl_intro.h"

#include "camera.h"

extern terrain_t *terrain;	/* notre terrain */

#endif
